<template>
  <div>
    <div class="mt-4" v-if="dataLoaded">
      <gl-alert :dismissible="false" class="mb-3">
        The original resulting CSS (locally from GDK)
      </gl-alert>
      <b-form-input
        v-if="true == false"
        v-model="searchString"
        type="search"
        placeholder="Search ..."
        @input="doSearch"
        :autofocus="true"
      ></b-form-input>

      <code style="white-space: pre-line;">
        {{ this.cssContent }}
      </code>
    </div>
    <div class="mt-4" v-if="!dataLoaded">
      Loading ...
    </div>
  </div>
</template>

<script>
import axios from 'axios';
import _ from 'lodash';
import FlexSearch from 'flexsearch';
import { GlAlert, GlLink, GlTable } from '@gitlab/ui';

let searchIndex;

export default {
  components: {
    GlTable,
    GlAlert,
    GlLink,
  },
  fields: [
    {
      key: 'selector',
      label: 'Selector',
      sortable: true,
    },
    {
      key: 'rulesLength',
      label: 'Rules Length',
      sortable: true,
    },

    {
      key: 'selectorLength',
      label: 'Selector Length',
      sortable: true,
    },
    {
      key: 'file',
      label: 'File',
      sortable: true,
    },
  ],
  data() {
    return {
      searchString: this.$route.query.q,
      dataLoaded: false,
      totalSelectors: 0,
      cssContent: null,
      results: [],
    };
  },
  mounted() {
    this.initSearch();
  },
  methods: {
    convertRuleString: function (val) {
      return val.replace(/,/gi, ';<br/>');
    },
    doSearch: _.debounce(function (newVal) {
      if (newVal && searchIndex) {
        this.results = searchIndex.search(newVal);
        console.log('RES : ', this.results);
      } else {
        this.results = [];
      }
    }, 300),
    async initSearch() {
      const { data } = await axios.get('application-local.css');
      this.totalSelectors = data.length;
      this.cssContent = data;
      this.dataLoaded = true;

      /*
      searchIndex = new FlexSearch({
        encode: 'icase',
        tokenize: 'strict',
        threshold: 1,
        resolution: 3,
        depth: 2,
        worker: 4,
      });
      const lines = data.split(/\r?\n/);
      lines.forEach((val, ind) => {
        searchIndex.add(ind, val);
      });

      this.dataLoaded = true;

      if (this.searchString) {
        this.results = searchIndex.search(this.searchString);
      }
      */
    },
  },
};
</script>
